<?php
	
	
	class In8_Queue {
		
		public $id = NULL;
		public $recurrence = NULL;
		public $limit = NULL;
		
		public function __construct() {
			
			
			$this->recurrence = apply_filters( "in8_queue_recurrence", $this->recurrence == NULL ? "hourly" : $this->recurrence, $this->id );
			$this->limit      = apply_filters( "in8_queue_limit", $this->limit == NULL ? 2 : $this->limit, $this->id );
			
			add_action( 'in8_queue_processQueue_' . $this->id, [
				$this,
				'processQueue',
			] );
			
			add_action( 'init', function () {
				// register the event
				if ( ! wp_next_scheduled( 'in8_queue_processQueue_' . $this->id ) ) {
					wp_schedule_event( time(), $this->recurrence, 'in8_queue_processQueue_' . $this->id );
				}
				
				if ( isset( $_REQUEST['in8_processQueue'] ) && $_REQUEST['in8_processQueue'] == $this->id ) {
					$this->processQueue();
					exit;
				}
			} );
		}
		
		public function getEntities() {
			return [];
		}
		
		public function _getEntities() {
			return apply_filters( 'in8_queue_entities', $this->getEntities(), $this );
		}
		
		public function shouldProcess( $entity ) {
			return TRUE;
		}
		
		public function _shouldProcess( $entity ) {
			return apply_filters( 'in8_queue_shouldProcess', $this->shouldProcess( $entity ), $entity, $this );
		}
		
		public function processQueue() {
			$entities = $this->_getEntities();
			
			$i = 0;
//			do_action('in8_queue_before_process', $this);
			
			foreach ( $entities as $entity ) {
				
				if ( ! $this->_shouldProcess( $entity ) ) {
					continue;
				}
				
				$this->processEntity( $entity );
				$i ++;
				if ( $i >= $this->limit ) {
					break;
				}
			}

//			do_action('in8_queue_after_process', $this);
		}
		
		
		public function processEntity( $entity ) {
			return TRUE;
		}
		
	}
	